'-------------------------------------------------------------------------------
'          OLEDsh1106.bas
'          Sample to demo the 128x64 I2C OLED display
'           Line/Circle/Pset  not supported.
'-------------------------------------------------------------------------------
$regfile = "m88pdef.dat"
'$regfile = "m328pdef.dat"
$hwstack = 32
$swstack = 32
$framesize = 32
$crystal = 8000000
Config Clockdiv = 1                                         ' make sure the chip runs at 8 MHz

Config Scl = Portc.5                                        ' used i2c pins
Config Sda = Portc.4
Config Twi = 400000                                         ' i2c speed

I2cinit
$lib "i2c_twi.lbx"                                          ' we do not use software emulated I2C but the TWI
$lib "glcdSH1106-I2C.lib"                                   ' override the default lib with this special one

#if _build < 20784
Dim ___lcdrow As Byte , ___lcdcol As Byte                   ' dim these for older compiler versions
#endif

Config Portb = &B00000010                                   '1out

Dim N As Byte , M As Byte , L As Byte , K As Byte
Dim Page As Byte

N = 0
Set Portb.1                                                 'Res Hi
Delay
Reset Portb.1                                               'Res low
Delay
Set Portb.1                                                 'Res Hi
Delay

Config Graphlcd = Custom , Cols = 128 , Rows = 64 , Lcdname = "SH1106"
Cls
Setfont Font8x8tt                                           ' select font

Do
   Lcdat 1 , 1 , "BASCOM-AVR"                               'TXT disp
   Lcdat 2 , 10 , "2017"
   Lcdat 3 , 1 , "OLED 1.3"
   Lcdat 4 , 10 , "SH1106"
   Lcdat 5 , 10 , N
   Lcdat 7 , 4 , "Demo" , 1
   Wait 2

   Showpic 0 , 0 , Plaatje                                  'BMP disp
   Wait 2
'
'   Cls
   For L = 0 To 7                                           'Top to Bottom
   Page = &HB0 + L                                          ' SH1106 only
   Glcdcmd Page                                             'Page Addres 0-7 set (SH1106)
   Glcdcmd &H00                                             'Column Addres L reset (SH1106)
   Glcdcmd &H10                                             'Column Addres H reset (SH1106)
   K = 1
      For M = 1 To 128                                      'Left to Right
         Glcddata K                                         'data Disp
         Rotate K , Left , 1
      Next M
   Next L
   Wait 3
   Cls
   N = N + 1
Loop

End

$include "font8x8TT.font"                                   ' this is a true type font with variable spacing

Plaatje:
$bgf "ks108.bgf"                                            ' include the picture data